<?php
 /*
 Download from http://www.finerimage.com.au/Downloads/rapidealbum/

Copyright  2013 Phil Tanner, Finer Image.

Other license terms are available for a fee. All licensing enquiries must be sent to info@finerimage.com.au 

LICENSE (Free Version)

Anyone receiving this software and related documentation (the Software) my use and distribute the Software free of charge subject to the following conditions:
The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

You may use the Software under this license to produce up to 5 galleries on 1 domain or 1 sub domain.

You will not amend, remove, hide, obscure or obfuscate the attribution and hyperlink to finerimage.com.au.

Other than altering the 'USER Config Section' of the Software and embedding your own gallery or album page html, you will not alter the Software. You will not reverse engineer the Software.

You will not use the Software for content that is violent, discriminatory, unlawful, infringing, hateful, pornographic or likely to be damaging to the author.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

class Img_Process {
 
public $image;

public function build_from_encoding_type()
{
	$img_info = @getimagesize($this->image['file_path']);
	
	if($img_info!==NULL)
	{	
		$this->image['encoding_type']=$img_info[2];	
	
		switch($this->image['encoding_type'])
		{
			case IMAGETYPE_JPEG:
			$this->image['object'] = imagecreatefromjpeg($this->image['file_path']);
			break;
			case IMAGETYPE_PNG:
			$this->image['object'] = imagecreatefrompng($this->image['file_path']);
			break;
			case IMAGETYPE_GIF:
			$this->image['object'] = imagecreatefromgif($this->image['file_path']);
			break;
			
			default:
			return false;
		}
	}
	else
	{
		return FALSE;	
	}
	
return TRUE;
}

public function GetImgWidth() 
{
return imagesx($this->image['object']);
}
   
public function GetImgHeight()
{
return imagesy($this->image['object']);
}
   
public function ResizeToMAX($max_size)
{
$req_ratio = $max_size/(max($this->GetImgWidth(),$this->GetImgHeight()));
$this->image['new_width'] =  $req_ratio*$this->GetImgWidth();
$this->image['new_height'] = $req_ratio*$this->GetImgHeight();
$this->ResizeImg();
}

public function ResizeImg()
{
$new_image = imagecreatetruecolor($this->image['new_width'], $this->image['new_height']);
imagecopyresampled($new_image, $this->image['object'], 0, 0, 0, 0, $this->image['new_width'], $this->image['new_height'], $this->GetImgWidth(), $this->GetImgHeight());
$this->image['object'] = $new_image;
}   
   
      
function save($path,$file_name, $quality)
{
	switch($this->image['encoding_type'])
	{
		case IMAGETYPE_JPEG:	
		imagejpeg($this->image['object'],$path."/".$file_name,$quality);
		break;
		
		case IMAGETYPE_PNG:
		imagepng($this->image['object'],$path."/".$file_name);
		break;
		
		case IMAGETYPE_GIF:
		imagegif($this->image['object'],$path."/".$file_name);
		break;		
	}
// Free up memory
imagedestroy($this->image['object']);
}

//end class
}

function make_thumbs($quality,$max_dims)
{
$JPEG_quality = $quality;
$max_dimension_pixels = $max_dims;
$relative_path = dirname($_SERVER["PHP_SELF"]);
$image_path = $_SERVER['DOCUMENT_ROOT'].$relative_path.'/img';
$thumb_path = $_SERVER['DOCUMENT_ROOT'].$relative_path.'/thumbnails';
if(!is_dir($thumb_path)){if (!mkdir($thumb_path, 0755)){die('Could not create thumbnail folder');};};
$dir_handle = opendir( "$image_path" );
$photo_info = array();
while(false !==( $file = readdir($dir_handle)))
{
	set_time_limit(30); 
// acceptable file types....
if (preg_match('/(jpg|jpeg|gif|png)$/i',$file)) 
{
	$file_full_path = $image_path."/".$file;
	$image = new Img_Process();
	$image->image['file_path'] = $file_full_path;
	if($image->build_from_encoding_type()!==FALSE)
	{
		$image->ResizeToMAX($max_dimension_pixels);
		$image->save($thumb_path,$file,$JPEG_quality);	}
	}
	
}

}
?>